import string, time

import AccessControl.Owned, AccessControl.SecurityManagement, AccessControl.User
import Globals
from App import ApplicationManager
from OFS.Folder import Folder
import ZODB

from MountedStorage import MountManager

MountFolderID='Mounts'

def _addMountManager(self, item, mount_manager):
    # "Log on" as system user
    AccessControl.SecurityManagement.newSecurityManager(
        None, AccessControl.User.system)

    root = self.getPhysicalRoot()
    id = string.join(list(self.getPhysicalPath()) + [item.id], '~')
    params = eval(item._params)
    
    if MountFolderID not in root.objectIds():
        mf = MountFolder()
        root._setObject(MountFolderID,mf)

    if id in root[MountFolderID].objectIds():
        root[MountFolderID]._delObject(id)

    root[MountFolderID].manage_addMountManager(id=id,title='',params=params,mount_manager=mount_manager)

    # "Log off" as system user
    AccessControl.SecurityManagement.noSecurityManager()

def _delMountManager(self, item):
    # "Log on" as system user
    AccessControl.SecurityManagement.newSecurityManager(
        None, AccessControl.User.system)

    root = self.getPhysicalRoot()
    id = string.join(list(self.getPhysicalPath()) + [item.id], '~')
    
    if MountFolderID in root.objectIds():
        if id in root[MountFolderID].objectIds():
            root[MountFolderID].manage_delObjects(ids=[id,])

    # "Log off" as system user
    AccessControl.SecurityManagement.noSecurityManager()

class MountFolder(Folder):
    '''
    Manage a collection of Mounts
    '''

    id        ='Mounts'
    name=title='Mount Management'
    meta_type ='Mount Management Folder'
    icon='p_/DatabaseManagement_icon'

    all_meta_types={'name': MountManager.meta_type, 'action': 'manage_addMountManagerForm'},
    meta_types=all_meta_types

    # This prevents subobjects from being owned!
    _owner=AccessControl.Owned.UnownableOwner

    def _mount(self, name): return getattr(self, name)

    def manage_addMountManager(self, id, title, params, mount_manager, REQUEST=None):
        ' '
        mm=mount_manager(id=id, title=title, params=params)
        self._setObject(id,mm)
        if REQUEST is not None:
            return self.manage_main(self,REQUEST,update_menu=1)
        
    def _canCopy(self, op=0):
        return 0

Globals.default__class_init__(MountFolder)

