""" Support for mounting a filestorage. 
    Code derived from the original OFS/MountedItem.py which has now disappeared
    from the CVS.

    Use at your own risk. There's probably gods only know special badness 
    awaiting users of this. 
"""

import time
import Globals
import ZEO.ClientStorage

from MountedStorage import MountedStorageMixin, MountedStorage, MountManager
from ApplicationManager import _addMountManager

class ClientStorageMixin(MountedStorageMixin):
    def _createStorage(self):
	""" Gets the Storage object.
        """
        params = eval(self._params)
        host = params['host']
        port = int(params['port'])
        name = '%s@%s:%s' % (params['storage'], params['host'], params['port'])
        storage = params['storage']
        path = params['path']
        create = params['create']
        
        return ZEO.ClientStorage.ClientStorage(connection=(host,port),name=name,storage=storage,wait_for_server_on_startup=0,client=name)

class ClientStorage(ClientStorageMixin, MountedStorage):
    '''A MountPoint with a basic interface for displaying the
    reason the database did not connect.
    '''

    meta_type = 'MountedClientStorage'
    
    def __init__(self, id, host, port, storage, title='', path=None, create=None):
        params = {'host':host,'port':port,'storage':storage}
        MountedStorage.__init__(self,id,title,path,create,params)

class ClientStorageManager(ClientStorageMixin, MountManager):
    '''
    A manager for Mounted ClientStorage.
    '''
    meta_type = 'MountedClientStorage Mount Management'

    def db_size(self):
        info = self._getDB()._storage._call('get_info')
        s=info['size']
        if type(s) is type(''): return s
        if s >= 1048576.0: return '%.1fM' % (s/1048576.0)
        return '%.1fK' % (s/1024.0)

    def manage_pack(self, days=0, REQUEST=None):
        """Pack the database"""

        t=time.time()-days*86400
        t = self._getDB()._storage.pack(t)
        if REQUEST is not None:
            REQUEST['RESPONSE'].redirect(
                REQUEST['URL1']+'/manage_workspace')
        return t


manage_addClientStorageForm=Globals.HTMLFile('dtml/addClientStorage',globals())

def manage_addClientStorage(self,id,host,port,storage,title='',path=None,create=None,REQUEST=None):
    """ add a mountpoint """
    ms = ClientStorage(id, host, port, storage, title, path, create)
    self._setObject(id, ms)
    _addMountManager(self, ms, ClientStorageManager)
    if REQUEST is not None:
	return self.manage_main(self, REQUEST)
